type  str130=string[129];
var reg:registers;
    line:str130;
    cpu,q,ii,err:integer;
    ch:char;
    cpuinform:cpu_info_t;

procedure cuon;
begin asm
 mov ah,$01
 mov ch,11
 mov cl,13
 int $10
end; end;

procedure cuoff;
begin asm
 mov ah,$01
 mov ch,$20
 int $10
end; end;

procedure tab(n:integer);
begin
 gotoxy(n,wherey);
end;

function centre(lin:str130):str130;
var winn:integer;
 li:str130;
begin
 li:='';
 winn:=(lo(windmax)+1) div 2;
 winn:=winn-(length(lin) div 2);
 for ii:=1 to winn do
  li:=li+' ';
 lin:=li+lin;
 for ii:=length(lin) to (lo(windmax)+1) do
  lin:=lin+' ';
 centre:=lin;
end;

function centre2(lin:str130; num:integer):str130;
begin
 tab(num-(length(lin) div 2));
 centre2:=lin;
end;

function comma(num:longint):str130;
begin
 str(num,line);
 ii:=length(line);
 while ii>3 do
 begin
  insert(',',line,ii-2);
  ii:=ii-3;
 end;
 comma:=line;
end;

procedure kbdflush;
var cc:char;
begin
 while keypressed do
  cc:=readkey;
end;

procedure kbdstat(num:integer);
begin
 mem[0:1047]:=num;
end;

procedure kbdrate(dd,rr:integer); {rr 0-30  dd 0-3}
begin
 reg.ah:=$03;
 reg.al:=$05;
 reg.ax:=$0305;
 reg.bl:=rr;
 reg.bh:=dd;
 intr($16,reg);
end;

procedure pause;
begin
 kbdflush;
 ch:=readkey;
end;


procedure upstr(var line:str130);
begin
 for ii:=1 to length(line) do
  line[ii]:=upcase(line[ii]);
end;

procedure cpuinfo(var cpu:integer; var fpu:boolean);
begin
 fpu:=false;
 cpu:=1;
 with cpuinform do
 begin
  test_type:='C';
  cpuid(cpuinform);
  case cpu_type of
  0..$05: cpu:=0;
     $06: cpu:=2;
     $07: cpu:=3;
     $08: cpu:=4;
  end;
  test_type:='N';
  cpuid(cpuinform);
  if ndp_type=$00 then fpu:=false
  else fpu:=true;
 end;
end;

procedure wait(wai:longint);
var temp:longint;
begin
if cpu=0 then delay(wai)
else begin
 reg.ah:=$86;
 temp:=wai*1000;
 reg.cx:=temp div 65535;
 reg.dx:=word(temp-longint(reg.cx*65535));
 intr($15,reg);
end;
end;

procedure beep;
begin
 sound(2000);
 wait(200);
 nosound;
end;

function date2:str130;
  var ye,mn,yy,d:word;
  mi:string[4];
  tm,dn:string[10];
 begin
   getdate(ye,mn,d,yy);
   case yy of
    0: dn:='SUN';
    1: dn:='MON';
    2: dn:='TUE';
    3: dn:='WED';
    4: dn:='THU';
    5: dn:='FRI';
    6: dn:='SAT';
   end;
{   mi:='';
   reg.ah:=$38;
   reg.dx:=0;
   reg.al:=0;
   reg.ds:=seg(line);
   reg.dx:=ofs(line);
   msdos(reg);
   ch:=lo(reg.bx);
   line:='';
   if ch=1 then begin  }   {USA}
    if d<10 then mi:='0';
    str(mn:2,tm);
    tm:=tm+'-'+mi;   {mm-0}
    str(d,mi);
    tm:=tm+mi;       {mm-dd}
{   end
   else begin  }          {Int'l Eng}
{    if mi<10 then mi:='0';
    str(d:2,tm);}
    tm:=tm+'-'+mi;   {dd-0}
    str(mn,mi);
    tm:=tm+mi;       {dd-mm}
{   end;
   str(ye,mi);}
   date2:=tm+'-'+mi+' ('+dn+')';
 end;

function time2:str130;
var h,m,s,a:word;
    mi,dn:string[2];
    tm:string[10];
begin
   gettime(h,m,s,a);
   mi:='';
   if m<10 then
   if m<10 then
    mi:='0';
   dn:=' a';
   if h>11 then
   begin
    h:=h-12;
    dn:=' p';
    if h=0 then h:=12;
   end;
   str(h:2,tm);
   tm:=tm+':'+mi;
   str(m,mi);
   time2:=tm+mi+dn+'m';
end;

procedure fcopy(inf,outf:str130);
var fsp:searchrec;
qw:longint;
infile,outfile:text;
cc:char;
begin
   assign(infile,inf);
   reset(infile);
   if ioresult<>0 then
   begin
    err:=1;
    exit;
   end;
   assign(outfile,outf);
   rewrite(outfile);
   if ioresult<>0 then
   begin
    err:=1;
    exit;
   end;
   err:=0;
   findfirst(inf,anyfile,fsp);
   for qw:=1 to fsp.size do
   begin
    read(infile,cc);
    write(outfile,cc);
   end;
   close(infile);
   close(outfile);
end;

procedure fdel(filen:str130);
begin
 reg.ax:=$4100;
 reg.ds:=seg(filen[1]);
 reg.dx:=ofs(filen[1]);
 msdos(reg);
 err:=reg.flags;
end;

procedure fren(oldn,newn:str130);
begin
 reg.ax:=$5600;
 reg.ds:=seg(oldn[1]);
 reg.dx:=ofs(oldn[1]);
 reg.es:=seg(newn[1]);
 reg.di:=ofs(newn[1]);
 msdos(reg);
 err:=reg.flags;
end;

function getdrv:integer;
begin
 reg.ax:=$1900;
 msdos(reg);
 getdrv:=lo(reg.ax);
 err:=reg.flags;
end;

procedure setdrv(drv:integer);
begin
 reg.ax:=$0e00;
 reg.dx:=drv;
 msdos(reg);
 err:=reg.flags;
end;

function hex(a : word; b : byte) : string;
  const
    digit : array[$0..$F] of char = '0123456789ABCDEF';
  var
    i : byte;
    xstring : string;
 begin
  xstring:='';
  for i:=1 to b do
    begin
    insert(digit[a and $000F], xstring, 1);
    a:=a shr 4
    end;
  hex:=xstring
 end; {hex}

function cbw(a, b : byte) : word;
 begin
  cbw:=word(b) shl 8 + a
 end; {cbw}
