program DOSDO_20;
{Written by Hunter Beanland - www.geocities.com/hbeanland }
{$I-}
{$M 8000,87500,110000}
uses
  dos,crt,graph,ifpextrn;
type oneline=string[100];
     lnbuf=array[1..850] of ^oneline;
var
  opt,mi,dn:string[10];
  psi:string[130];
  loop:array[1..5,1..2] of integer;
  jumpn:array[1..5] of integer;
  jumpp,posit,pc,j,lx,ly,cx,cy,tx,ty,tw,tz,x,shape,
   cofor,cobac,loopn,endln,linen,c,y,w,z,cux,cuy,i:integer;
  z2,pn,pnn,pn2:longint;
  rn:real;
  h,m,s,a,d,mn,ye,yy:word;
  cga,found,last,ok,ex,sh,fr:boolean;
  res:char;
  infile:text;
  filesp:searchrec;
  scrns:array[0..11] of pointer;
  linebuf:lnbuf;
const
  colours:array[0..8] of string[3]=('BLA','BLU','GRE','CYA','RED','MAG','BRO','WHI','SAM');
{$I screen.pas}
var ps:string[130];
    pstr:array[1..20] of string[130];

procedure stop2(num:integer);              { set cursor & halt }
begin
  cumod(cutop,cubot);
  gotoxy(cux,cuy);
  textattr:=7;
  halt(num);
end;

procedure ctrlc;                       { ^C interrupt vector points here }
begin
 kbdflush;
 stop2(0);
end;

procedure stop (code,exp:integer);      { display error codes, call stop2 }
var msg,msg2:string[70]; lin:string[4];
begin                                    { uses ps sometimes }
  textattr:=207;
  str(linen,lin);
  line:=' expected';
  case exp of
   0: msg2:='''';
   1: msg2:=''', '',''';
   2: msg2:=''', ''"''';
   3: msg2:=''', number';
   4: msg2:=''', colour';
  end;
  if msg2<>'''' then msg2:=msg2+line;
  case code of
  1: msg:='Invalid option in line '+lin+':'''+opt;
  2: msg:='Invalid parameter in line '+lin+':'''+ps;
  3: msg:='Parameters missing in line '+lin+':'''+opt;
  4: begin
      if doserror<4 then msg:='Not found'
      else str(doserror,msg);
      msg:='File/Disk error, ('+msg+') in line '+lin+':'''+ps;
     end;
  5: begin msg:='Line too long or too many parameters in line '+lin; msg2:=''; end;
  6: begin
      str(pn,msg);
      msg:='Number out of range in line '+lin+':'''+msg;
     end;
  8: msg:='Can''t find Jump label in line '+lin+':'''+ps;
  9: msg:='Not enough memory/program resources in line '+lin;
  10: msg:='Screen frame already in use in line '+lin;
  11: msg:='Too many nested loops/jumps in line '+lin;
  12: msg:='Too many returns/loop ends in line '+lin;
  end;
  if code>8 then msg2:='';
  cuy:=ly;
  gotoxy(cux,cuy);
  write(#10#13'DOS-DO ERROR = '); textattr:=79; write(msg,msg2,#13#10);
  sound(2000);
  wait(200);
  nosound;
  stop2(255);
end;

procedure scrnsize;                      { find screen size }
begin
  lx:=lo(windmax)+1;                       { into lx, ly }
  ly:=hi(windmax)+1;
end;

procedure mpage(sho:boolean);             { more page seperator }
begin
 gotoxy(1,hi(windmax)+1);
 repeat
  write(#13'- More -');
  if sho then write(' 44 Options listed in 9 pages');
  wait(100);
  write(#13'= More =');
  wait(100);
  write(#13' More ');
  wait(100);
  write(#13'= More =');
  wait(100);
 until keypressed;
 ch:=readkey;
 if ch=#3 then stop2(0);
 clrscr;
end;


procedure start;                { start up, & display help if applic }
begin
  videoini;
  pc:=paramcount;
  scrnsize;
  cuget;
  cuoff;
  reg.ah:=33;  { set dos ^c check on }
  reg.al:=1;
  reg.dl:=1;
  msdos(reg);
  setintvec($23,addr(ctrlc));
  if pc=0 then
  begin
    textattr:=31; clrscr;
    writeln('== DOS-DO ==   v 2.0                                  H.BEANLAND    Copyright 92');
    writeln('BATCH FILE ENHANCER / DOS COMMAND ACCESSORIES');
    writeln('SYNTAX: DO [Option] [Parameters]    (See DOMAN.DOC for more help)');
    writehorz(196,80);
    writeln(#10'               OPTIONS LIST / NOTES                            LEGEND');
    writehorz(196,80);
    gotoxy(52,5); write('');
    gotoxy(52,6); write('');
    gotoxy(52,7); write('');
    gotoxy(52,8); writevert(179,17); textcolor(7); window(54,8,80,25);
    writeln('Use "," where specified');
    writeln('Keywords are in upper case');
    writeln('(xxx)  optional parameters');
    writeln('x|y=0  x or y =at cursor');
    writeln('F      FROM file only');
    writeln('R      produces Result');
    write  ('R val  0=ok 1=N 2=Y 255=err');
    writeln('..     list of');
    writeln('tc     text colour');
    writeln('bc     background colour');
    writeln('bdc    border colour');
    writeln('xt,yt  top co-ords');
    writeln('xb,xb  bot co-ords');
    writeln('dd     delay');
    writeln('ff     frequency');
    writeln('kk     key (case insens)');
    writeln('ll     no. of loops');
    writeln('nl,cl,sl  kbd locks');
    window(8,25,80,25);
    write('Colours=(f)(l)Black,Blue,Green,Cyan,Red,Magenta,Brown,White,Same');
    window(1,8,50,24);
    writeln('BOOT    (COLD/DOS)'#13#10'         Defaults to warm, no return!'#10);
    writeln('BOX     xt,yt xb,yb tc bc 0/1/2'#10#13'         Box in no/sing/doub outline'#10);
    writeln('C:PRES'#10#13'  R      Is C: present?'#10);
    writeln('CLS     (NORM/FADE/DROP/LIFT/SLID/IMPL) tc bc bdc'#10#13'         Clears screen by 1 of the 6'#10);
    writeln('CPUTYPE'#13#10'  R      What type of CPU? 1=XT  2=AT  3=DX/SX'#10);
    mpage(true);
    writeln('CURSOR  NONE/SMALL/NORM/MED/LARGE'#10#13'         Changes cursor''s size'#10);
    writeln('DATE    x,y tc bc'#10#13'         Displays date, "dd-mm-yyyy (day)" or USA'#10);
    writeln('DOS     (params)'#10#13'         Writes commands through to dos. Gives dos'#13,
            '         shell if no parameters are passed'#10);
    writeln('DOSVER  MINOR/MAJOR'#10#13'  R      What is minor/major parts of dos ver?'#10);
    writeln('ECHO    x,y tc bc "text"'#10#13'         Echos " text in quotes"'#10);
    mpage(true);
    writeln('ECHOCH  x,y tc bc ch ff HORZ/VERT'#10#13'         Echo ch, ff times in direc (ch=ansi code)');
    writeln('EMSFREE x,y tc bc'#13#10'         Displays free EMS in Bytes'#10);
    writeln('EMSPRES'#13#10'  R      Is EMS present?'#10);
    writeln('EMSTOT  x,y tc bc'#13#10'         Displays total EMS in Bytes'#10);
    writeln('EXISTS  d:\name'#10#13'  R      Does dir or file exist?'#10);
    mpage(true);    
    writeln('EXIT    el'#13#10'  R      Exit to Dos with error level'#10);
    writeln('FPUPRES'#13#10'  R      Is FPU (co-pro) present?'#10);
    writeln('FROM    file.ext'#10#13'         Take all commands out of the file'#10);
    writeln('GETKEY  kk .. (BEEP)'#10#13'  R      What key was pressed in list? Wildcard'#10#13,
            '         excepted. Beep if non-listed key hit'#10);
    writeln('GOLINE  (+/-)y'#10#13'         Goto line, or inc/dec line by y'#10);
    mpage(true);
    writeln('ISVOL   (d:) label/NONE'#10#13'  R      Is disk vol label same?'#10);
    writeln('JUMP    label'#10#13'  F      Jump (goto) label, (see RETURN)'#10);
    writeln('KBDIN   (CLR) "text"/cc ..'#10#13'         Put text/code into Kbd buffer  15 chars'#10);
    writeln('KBDRATE dd,ff'#10#13' AT      Change Kbd rates (0-3, 0-32)'#10);
    writeln('KBDSTAT nl,cl,sl'#10#13' AT      Change Kbd lock status (+on -off =same)'#10);
    mpage(true);
    writeln('LOOP    START ll/END'#10#13'  F      Loop enclosed commands (max 5 nested)'#10);
    writeln('MEMFREE x,y tc bc'#13#10'         Displays free base in Bytes'#10);
    writeln('MEMSIZE'#13#10'  R      What is mem size?  1<512k 2=512k 3=640k'#10);
    writeln('PRTSCR'#10#13'         Print screen'#10);
    writeln('REM'#13#10'  F      Remark line only, ignore line'#10);
    mpage(true);
    writeln('RETURN'#13#10'  F      Return to last Jump line (max 5 nested)'#10);
    writeln('RESULT  kk label/>option'#13#10'         Jump/exec option if result = kk or ?'#10);
    writeln('SOUND   SIREN/BEEP/RANDOM/RISE/FALL dd'#13#10'        ff,dd ..'#13#10'         Sound in Hz and ms'#10);
    writeln('TIME    x,y tc bc'#13#10'         Displays time, "hh:mm:ss Xm"'#10);
    writeln('TYPE    xt,yt xb,yb tc bc file.ext (MORE)'#10#13'         Type file in a window'#10);
    mpage(true);
    writeln('VIDCOL  CO/BW/HI/LO'#10#13'         Change video colour bits'#10);
    writeln('VIDMODE LOW/NORM/MED/HIGH'#10#13'         Change video modes'#10);
    writeln('VIDTYPE'#13#10'  R      What video?  mono=1 cga=2 ega=3 vga=4'#10);
    writeln('WAIT    (.)dd'#10#13'         Wait in sec''s or ms if ''.'' is used'#10);
    writeln('WILLFIT filemask d:'#10#13'  R      Check if file(s) will fit on drive'#10);
    mpage(true);
    writeln('WINCOL  xt,yt xb,yb tc bc'#13#10'         Colours a window leaving chars'#10);
    writeln('WINDISK SAVE xt,yt xb,yb file.ext (BIN)'#10#13'        REST file.ext'#10#13,
            '         Copy screen to/from disk'#10);
    writeln('WINDOW  xt,yt xb,yb tc bc (EXPL)(SHAD) 0/1/2'#10#13'         Make a window'#10);
    writeln('WINMEM  SAVE tx,ty bx,by scr#'#10#13'        REST (tx,ty) scr# (KEEP)'#10#13,
            '         Save/restore upto 10 windows to memory'#10);
    writeln(':       label'#13#10'  F      Label marker');
    mpage(false);
    cuy:=1;
    stop2(255);
  end;
  if pc>20 then stop(5,0);
  fr:=false;
  for q:=1 to pc do begin
   pstr[q]:=paramstr(q);
   if pos('"',pstr[q])>0 then fr:=true;
   if not fr then upstr(pstr[q]);
  end;
  cux:=wherex;
  cuy:=wherey;
  ok:=false;
  fr:=false;
  randomize;
  jumpp:=0;
  cofor:=0; cobac:=0;
  if textattr>128 then begin cofor:=128; cobac:=cobac-8; end;
  cobac:=cobac+(lo(textattr) shr 4);
  cofor:=cofor+(((lo(textattr)) shl 12) shr 12);
  linen:=1;
  for i:=0 to 11 do
   scrns[i]:=nil;
  cpuinfo(cpu,ex);
 end;

procedure convert(num:integer;sto:boolean);    { conv str to num }
begin
  ps:=pstr[num];                               { ps to pn, if true stops }
  val(ps,pn,c);
  if pn<0 then pn:=abs(pn);
  if sto and (c<>0) then stop(2,3);
  if sto and (pn>32000) and (opt<>'WAIT') then stop(6,0);
end;

procedure checkp;                      { stop if <2 params }
begin
 if pc=1 then stop(3,0);
end;

procedure par(xx:integer);             { download & truncate param }
begin
 ps:=copy(pstr[xx],1,3);
end;

procedure delfirst;                       { dels 1st char }
begin
 delete(pstr[2],1,1);                      { in pstr[2] }
end;

procedure xypm(xory:integer);             { inc/dec cursor loc }
begin
  q:=0;                                    { if x|y=2 then is y }
  if copy(pstr[2],1,1)='-' then q:=1;
  if copy(pstr[2],1,1)='+' then q:=2;
  if q>0 then delfirst;
  convert(2,true);
  if xory=2 then begin
   if q=1 then pn:=wherey-pn;
   if q=2 then pn:=wherey+pn;
  end
  else begin
   if q=1 then pn:=wherex-pn;
   if q=2 then pn:=wherex+pn;
  end;
end;

procedure xygo(maxx:integer);            { gotoxy with max x coord }
begin
  psi:=pstr[2];                             { pstr[2] & colours }
  posit:=pos(',',psi);
  if posit=0 then begin
   ps:=psi;
   stop(2,1);
  end;
  pstr[2]:=copy(psi,1,(posit-1));
  xypm(1);
  x:=pn;
  if x<1 then x:=wherex;
  pstr[2]:=copy(psi,posit+1,length(psi)-posit);
  xypm(2);
  y:=pn;
  if y<1 then y:=wherey;
  if x>lx then x:=lx;
  if y>ly then y:=ly;
  if (maxx>0) and (x>maxx) then x:=maxx;
  gotoxy(x,y);
  textcolor(cofor); textbackground(cobac);
end;

procedure sepcom(var x,y:integer; ww:integer);   { seperate nums from comma }
begin
  psi:=pstr[ww];                                { pstr[ww] in,  x,y is seper }
  posit:=pos(',',psi);
  if posit=0 then begin
   ps:=psi;
   stop(2,1);
  end;
  pstr[ww]:=copy(psi,1,(posit-1));
  convert(ww,true);
  x:=pn;
  pstr[ww]:=copy(psi,posit+1,length(psi)-posit);
  convert(ww,true);
  y:=pn;
end;

procedure xywin(seek:boolean);         { check coords & seek if appic }
begin
  sepcom(x,y,2);                       { coords at pstr[2,3], true to seek }
  if seek then begin
   gotoxy(x,y);
   textcolor(cofor); textbackground(cobac);
  end;
  sepcom(w,z,3);
  if w<x then w:=x;
  if z<y then z:=y;
  if x<1 then x:=1;
  if y<1 then y:=1;
  if w>lx then w:=lx;
  if z>ly then z:=ly;
end;

procedure scr2(le:integer);       { direct scrn write char in curr colours }
 begin
   mem[video:(((lx*(wherey-1))+wherex)*2)-1]:=textattr; {(cobac shl 4)+ cofor;}
   mem[video:(((lx*(wherey-1))+wherex)*2)-2]:=le;
 end;

procedure scr3;                   { direct scrn write space in curr colours }
 begin
   mem[video:y-1]:=textattr; {(cobac shl 4)+ cofor;}
   mem[video:y-2]:=32;
 end;

procedure sc(xx,yy:integer);          { direct scrn write in new colours }
 begin                                      { leaving char }
  tw:=0; ii:=0;
  i:=mem[video:((((lo(windmax)+1)*(yy-1))+xx)*2)-1];
  if i>127 then begin ii:=128; tw:=-8; end;
  tw:=tw+(i shr 4);
  ii:=ii+((i shl 12) shr 12);
  if ex then cofor:=ii;
  if sh then cobac:=tw;
  mem[video:((((lo(windmax)+1)*(yy-1))+xx)*2)-1]:=(cobac shl 4)+cofor;
 end;

procedure chcol(back:boolean);    { register new colour }
begin
 if pn=-8 then exit;
 if back then cobac:=((integer(pn)) shl 13) shr 13
  else cofor:=pn;
 textattr:=(cobac shl 4)+cofor;
end;

procedure colour(where:integer);        { conv colour names to num }
begin
 ps:=pstr[where];                       { pstr[where], t=0 tc & bc }
 pn:=0;                                         { t=1 bc, t=2 brdc }
 if copy(ps,1,1)='F' then begin
  pn:=128;
  delete(ps,1,1);
 end;
 if copy(ps,1,1)='L' then begin
  pn:=pn+8;
  delete(ps,1,1);
 end;
 if length(ps)<3 then stop(2,4);
 found:=false;
 for q:=0 to 8 do
  if copy(ps,1,3)=colours[q] then begin
   found:=true;
   pn:=pn+q;
   if q=8 then pn:=-8;
  end;
 if not found then stop(2,4);
end;

procedure quotes;                      { take the text out of the quotes }
begin
  ps:=pstr[pc];
  if pos('"',line)=0 then stop(3,2);
  while line[1]<>'"' do delete(line,1,1);
  delete(line,1,1);
  if pos('"',line)=0 then stop(2,2);
  delete(line,pos('"',line),length(line));
end;

procedure cmdline;                      { get the real command line }
begin
 if not fr then begin
  h:=word(prefixseg);
  i:=$82;
  line:='';
  repeat
   q:=mem[h:i];
   line:=line+char(q);
   inc(i);
  until (q=$d);
 end;
end;

procedure winbox(pcc:integer; boxonly:boolean); { logic for wind/box extras }
begin
 par(pcc);
 if length(ps)>4 then ps:=copy(ps,1,4);
 if ps='EXP' then ex:=true;
 if ps='SHA' then sh:=true;
 if pcc=6 then begin
  convert(6,true);
  if pn>2 then stop(6,0);
  shape:=pn;
 end;
 ps:='EXP';
 if boxonly and ex then stop(2,0);
end;

procedure readit;                          { read from FROM file buffer }
begin
  line:=linebuf[linen]^;
end;

procedure result(level:integer; yn:boolean);      { handle result }
begin
 if not fr then stop2(level)                    { el, true if res Y/N }
 else if yn then begin
  if level=1 then res:='N'
  else res:='Y';
 end else res:=chr(level);
end;

procedure options;      { local option execution ***************************}
label agn,don,resu,startl;
begin
 startl:
 if opt='ABOUT' then
  begin
   textattr:=31;
   gotoxy(1,ly);
   writeln;
   write('About: == DOS-DO ==  v 2.0  (C) 92      '#13#10);
   write('By:    Hunter Beanland, Bris. Australia '#13#10);
   write('Stat:  DO.EXE  24040  5:00pm  26-01-92  '#13#10);
   ok:=true;
   cuy:=ly;
  end;

 if opt='BOOT' then                          { boot (cold/dos) }
  begin
   if pc>1 then begin
    par(2);
    if ps='COL' then inline($ea/$00/$00/$ff/$ff) else
    if ps='DOS' then begin cumod(cutop,cubot); intr($19,reg); end else
    stop(2,0);
   end;
   inline($b8/$40/$00/$8e/$d8/$c7/$06/$72/$00/$34/$12/$ea/$00/$00/$ff/$ff);
  end;

 if opt='C:PRES' then                 { c:pres }
  begin
   reg.ah:=$32;
   reg.dl:=3;
   intr($21,reg);
   if reg.al=$ff then result(1,true)
   else result(2,true);
   ok:=true;
  end;


 if opt='CLS' then     { cls norm/fade/drop/lift/slid/impl cofor cobac bord }
   begin
    if pc<5 then stop(3,0);
    colour(pc);
    bordercolor(pn);
    colour(4);
    chcol(true);
    colour(3);
    chcol(false);
    par(2);
    gotoxy(1,1);
    if ps='FAD' then begin
     write(' ');
     x:=lx*ly;
     for q:=1 to (x*4) do
     begin
      y:=random(x)*2+2;
      scr3;
     end;
    end else
    if ps='LIF' then begin
      for cuy:=1 to hi(windmax)+1 do begin
       delline;
       wait(10);
      end;
    end else
    if ps='IMP' then implode(1,1,lx,ly) else
    if ps='SLI' then begin
      scrns[10]:=savewin(1,1,lx-1,ly);
      for q:=2 to (lx-2) do begin
       restwin(q,1,scrns[10],false);
       gotoxy(q-1,1);
       for x:=1 to ly do
        scrn(q-1,x,32);
       wait(4);
      end;
      restwin(q+1,1,scrns[10],true);
     end else
    if ps='DRO' then begin
       for cuy:=1 to hi(windmax)+1 do begin
       insline;
       wait(10);
      end;
    end else if ps='NOR' then x:=2
    else stop(2,0);
    window(1,1,hi(windmax)+1,lo(windmax)+1);
    clrscr;
    cuy:=1;
    ok:=true;
   end;

 if opt='CPUTYPE' then                  { cputype }
   begin
    case cpu of
     0,1: result(1,false);
     2: result(2,false);
     3: result(3,false);
     4: result(4,false);
    end;
    ok:=true;
   end;

 if opt='CURSOR' then             { cursor none/small/norm/med/large }
  begin
   checkp;
   par(2);
   if ps='NON' then begin cutop:=9; cubot:=0; end else
   if ps='SMA' then begin cutop:=13; cubot:=13; end else
   if ps='NOR' then begin cutop:=8; cubot:=9 end else
   if ps='MED' then begin cutop:=10; cubot:=13; end else
   if ps='LAR' then begin cutop:=1; cubot:=13; end else
    stop(2,0);
   cumod(cutop,cubot);
   ok:=true;
  end;

 if opt='DATE' then                        { date xx,yy tc bc }
  begin
   checkp;
   xygo(65);
   if pc<4 then stop(3,0);
   colour(3);
   chcol(false);
   colour(4);
   chcol(true);
   getdate(ye,mn,d,yy);
   case yy of
    0: dn:='SUN';
    1: dn:='MON';
    2: dn:='TUE';
    3: dn:='WED';
    4: dn:='THU';
    5: dn:='FRI';
    6: dn:='SAT';
   end;
   mi:='';
   if mn<10 then mi:='0';
   reg.ah:=$38;
   reg.dx:=0;
   reg.al:=0;
   reg.ds:=seg(line);
   reg.dx:=ofs(line);
   msdos(reg);
   j:=lo(reg.bx);
   line:='';
   if d<10 then line:='0';
   if j=1 then write(mn:2,'-',line,d)
   else write(d:2,'-',mi,mn);
   write('-',ye,' (',dn);
   scr2(41);
   ok:=true;
  end;

 if opt='DOS' then                           { dos (params) }
   begin
     ok:=true;
     textattr:=15;
     if pc>1 then begin
      cmdline;
      delete(line,1,4);
      line:='/C '+line;
     end else begin
      line:='';
      writeln(#13,'Type ''EXIT'' to return.');
     end;
     cumod(cutop,cubot);
     swapvectors;
     exec(getenv('COMSPEC'),line);
     swapvectors;
     cuoff;
     scrnsize;
   end;

 if opt='DOSVER' then                 { dosver minor/major }
   begin
    checkp;
    par(2);
    if ps='MIN' then result(hi(dosversion),false)
    else if ps='MAJ' then result(lo(dosversion),false)
    else stop(2,0);
    ok:=true;
   end;

 if (opt='ECHO') then                 { echo xx,yy tc bc "text" }
    begin
     if pc<5 then stop(3,0);
     ok:=true;
     xygo(0);
     colour(3);
     chcol(false);
     colour(4);
     chcol(true);
     cmdline;
     quotes;
     write(line)
    end;

 if opt='ECHOCH' then              { echoch x,y tc bc j ff vert/horz }
  begin
   if pc<7 then stop(3,0);
   xygo(0);
   convert(5,true);
   j:=pn;
   if j>255 then stop(6,0);
   colour(3);
   chcol(false);
   colour(4);
   chcol(true);
   convert(6,true);
   par(7);
   if ps='VER' then writevert(j,pn)
   else  if ps='HOR' then writehorz(j,pn)
   else stop(2,0);
   ok:=true;
  end;

  if copy(opt,1,3)='EMS' then                   { detect ems }
   begin
    getintvec($67,scrns[10]);
    pn:=longint(scrns[10]);
    line:='';
    if pn>$00 then begin
     h:=pn shr 16;
     for x:=$0a to $11 do
      line:=line+chr(mem[h:x]);
    end;
   end;

  if (opt='EMSFREE') or (opt='EMSTOT') then   { emsfree x,y tc bc }
   begin                                      { emstot x,y tc bc }
    if pc<4 then stop(3,0);
    xygo(0);
    colour(3);
    chcol(false);
    colour(4);
    chcol(true);
    if line='EMMXXXX0' then begin
     reg.ah:=$42;
     intr($67,reg);
     if opt='EMSFREE' then pn:=reg.bx
     else pn:=reg.dx;
     write(comma(pn*16384),' (',pn*16,'K)');
    end else if line='' then write('NO EMS')
             else write('UNKNOWN');
    ok:=true;
   end;

  if opt='EMSPRES' then                   {R emspres }
   begin
    if line='EMMXXXX0' then result(2,true)
    else result(1,true);
    ok:=true;
   end;

  if opt='EXISTS' then                    {R exists d:\name }
   begin
    checkp;
    findfirst(pstr[2],anyfile,filesp);
    if doserror<>0 then result(1,true)
    else result(2,true);
    ok:=true;
   end;

 if opt='EXIT' then                         {R exit el }
  begin
   if pc<2 then stop(3,0);
   convert(2,true);
   if pn>255 then stop(6,0);
   stop2(pn);
  end;

 if opt='FPUPRES' then                 { fpupres }
   begin
    ex:=false;
    cpuinfo(cpu,ex);
    if ex then result(2,true) else
    result(1,true);
    ok:=true;
   end;

 if opt='GETKEY' then                  { getkey kk kk .. (beep) }
   begin
    ok:=true;
    checkp;
    x:=pc;
    par(pc);
    if ps='BEE' then begin
     ex:=true;
     x:=x-1;
    end;
agn:ch:=upcase(readkey);
    if copy(pstr[2],1,1)='?' then begin
     res:=ch;
     exit;
    end;
    for q:=2 to x do begin
     ps:=copy(pstr[q],1,1);
     if (not fr) and (ch=upcase(ps[1])) then stop2(q-1);
     if fr and (ch=upcase(ps[1])) then begin
      res:=ch;
      exit;
     end;
    end;
    if ex then begin
     sound(2000);
     wait(200);
     nosound;
    end;
    goto agn;
   end;

 if opt='GOLINE' then                      { goline (+/-)y }
   begin
    checkp;
    xypm(2);
    if not fr then pn:=pn-1;
    if pn>ly then pn:=ly;
    if pn<1 then pn:=1;
    gotoxy(1,pn);
    cuy:=pn;
    cux:=1;
    ok:=true;
   end;

 if opt='ISVOL' then                       { isvol (d:) volume/none }
  begin
   ok:=true;
   checkp;
   if pc>2 then begin
    ps:=pstr[2];
    line:=pstr[3];
   end else begin
    line:=pstr[2];
    ps:='';
   end;
   if length(line)>8 then insert('.',line,9);
   findfirst(ps+'\'+line,volumeid,filesp);
   if doserror=0 then result(2,true)
   else if (line='NONE') and (doserror=18) then result(2,true)
   else result(1,true);
  end;

 if (opt='JUMP') and fr then                    { jump label }
   begin
    ok:=true;
    checkp;
    ps:=pstr[2];
resu: if copy(ps,1,1)<>':' then ps:=':'+ps;   {from result}
    jumpp:=jumpp+1;
    if jumpp=6 then stop(11,0);
    jumpn[jumpp]:=linen;
    linen:=0;
    q:=0;
   repeat
    if endln=linen then begin linen:=jumpn[jumpp]; stop(8,0); end;
     inc(linen);
     readit;
     while copy(line,1,1)=' ' do delete(line,1,1);
     if copy(line,1,1)=':' then  begin
      upstr(line);
      if ps=copy(line,1,length(ps)) then q:=99;
     end;
   until q=99;
   exit;
   end;

 if opt='KBDIN' then                       { kbdin (CLR) "kk .."/cc cc .. }
  begin
   checkp;
   x:=2;
   ok:=true;
   if pstr[2]='CLR' then begin x:=3; kbdflush; end;
   ps:=pstr[x];
   if ps[1]<>'"' then begin       {codes not text}
   for y:=x to pc do begin
    ps:=pstr[y];
    reg.ah:=$05;
    reg.ch:=0;
    if ps[1]='0' then begin reg.cl:=$e0; intr($16,reg); end;
    reg.ah:=$05; reg.ch:=0;
    convert(y,true);
    if pn>255 then stop(6,0);
    reg.cl:=pn;
    intr($16,reg);
   end;
   end else begin
    cmdline;
    quotes;
    for q:=1 to length(line) do begin
     reg.ah:=$05;
     reg.ch:=0;
     reg.cl:=ord(line[q]);
     intr($16,reg);
    end;
   end;
 end;

 if opt='KBDSTAT' then                       { kbdstat nl,cl,sl }
  begin
   checkp;                                  { + on  - off  = same }
   ok:=true;
   q:=mem[0:1047];
   q:=q shr 4;
   ps:=pstr[2];
   delete(ps,2,1);
   delete(ps,3,1);
   ch:=ps[3];              {ncs}
   delete(ps,3,1);         {nc}
   insert(ch,ps,1);        {scn}
   for i:=1 to 3 do begin
    if i=3 then x:=4 else x:=i;
    if ps[i]='-' then begin if (q and x)=x then q:=q-x; end
    else if ps[i]='+' then begin if (q and x)=0 then q:=q+x; end
    else if ps[i]='=' then x:=x
    else stop(2,0);
    if i=4 then i:=3;
   end;
   q:=q shl 4;
   mem[0:1047]:=q;
  end;

 if opt='KBDRATE' then                          { kbdrate dd,ff }
  begin
   checkp;
   ok:=true;
   sepcom(i,q,2);
   if i>3 then stop(6,0);
   if q>32 then stop(6,0);
   q:=32-q;                {invert}
   kbdrate(i,q);
  end;

 if (opt='LOOP') and fr then                  { loop start ll/end }
   begin
    ok:=true;
    checkp;
    par(2);
    if ps='STA' then begin
     if pc<3 then stop(3,0);
     convert(3,true);
     loopn:=loopn+1;
     if loopn>5 then stop(11,0);
     loop[loopn,1]:=pn;
     loop[loopn,2]:=linen;
    end
    else begin
     if ps<>'END' then stop(2,0);
     if loopn=0 then stop(12,0);
     if loop[loopn,1]=1 then begin
      loopn:=loopn-1;
      exit;
     end;
     linen:=loop[loopn,2];
     loop[loopn,1]:=loop[loopn,1]-1;
    end;
   end;

 if opt='MEMFREE' then                    { memfree x,y tc bc }
   begin
    if pc<4 then stop(3,0);
    xygo(0);
    colour(3);
    chcol(false);
    colour(4);
    chcol(true);
    intr($12,reg);
    pn:=(longint(reg.ax)*1024)-(longint(prefixseg) shl 4);
    write(comma(pn),' (',pn/1024:0:0,'K)');
    ok:=true;
   end;

 if opt='MEMSIZE' then                      {R  memsize }
  begin
   intr($12,reg);
   pn:=reg.ax;
   case pn of
    0..511: result(1,false);
    0..592: result(2,false);
    0..640: result(3,false);
   end;
   ok:=true;
  end;

 if opt='PRTSCR' then                         { prtscr }
  begin
   ok:=true;
   intr($5,reg);
  end;

 if (opt='RETURN') and fr then                {F return }
   begin
    ok:=true;
    if jumpp=0 then stop(12,0);
    linen:=jumpn[jumpp];
    dec(jumpp);
   end;

 if (opt='RESULT') and fr then               { result kk label }
   begin
    ok:=true;
    if pc<3 then stop(3,0);
    convert(2,false);
    if ((c=0) and (ord(res)=pn)) or (ps[1]=res) or (ps[1]='?') then begin
     ps:=pstr[3];
     if ps[1]='>' then begin
      for q:=1 to (pc-2) do
       pstr[q]:=pstr[q+2];
       opt:=pstr[1];
       delete(opt,1,1);
       goto startl;
     end else goto resu;    {jump}
    end;
   end;

 if opt='SOUND' then                { sound ff,dd ff,dd .. }
    begin                           { sound siren/rise/fall/beep/random dd }
     checkp;
     ok:=true;
     x:=0;
     convert(3,false);
     pn:=pn div 1000;
     par(2);
     if ps='SIR' then
     repeat
      sound(1000);
      wait(500);
      sound(600);
      wait(500);
      x:=x+1;
     until x=pn else
     if ps='RIS' then
     repeat
      y:=30;
      repeat
       sound(y);
       wait(1);
       y:=y+3;
      until y>7000;
      x:=x+1;
     until x=pn else
     if ps='FAL' then
     repeat
      y:=7000;
      repeat
       sound(y);
       wait(1);
       y:=y-3;
      until y<30;
      x:=x+1;
     until x=pn else
     if ps='RAN' then
     repeat
      for z:=1 to 5 do begin
       sound(random(8000)+30);
       wait(200);
      end;
      x:=x+1;
     until x=pn else
     if ps='BEE' then
     repeat
      sound(800);
      wait(250);
      nosound;
      wait(250);
      sound(800);
      wait(250);
      nosound;
      wait(250);
      x:=x+1;
     until x=pn else
     for x:=2 to pc do begin
       sepcom(q,y,x);
       sound(q);
       wait(pn);
       nosound;
       wait(10);
     end;
     repeat
      sound(pn);
      pn:=pn+400;
     until pn>20000;
     nosound;
     wait(100);
    end;

 if opt='TIME' then                       { time xx,yy tc bc }
  begin
   if pc<4 then stop(3,0);
   xygo(73);
   colour(3);
   chcol(false);
   colour(4);
   chcol(true);
   gettime(h,m,s,a);
   mi:='';
   if m<10 then mi:='0';
   dn:=' a';
   if h>11 then begin
    h:=h-12;
    dn:=' p';
    if h=0 then h:=12;
   end;
   write(h:2,':',mi,m,dn);
   scr2(109);
   ok:=true;
  end;

 if opt='TYPE' then                    { type tx,ty bx,by tc bc file (more) }
   begin
    if pc <6 then stop(3,0);
    ok:=true;
    ps:=pstr[6];
    assign(infile,ps);
    reset(infile);
    if ioresult<>0 then stop(4,0);
    xywin(true);
    colour(4);
    chcol(false);
    colour(5);
    chcol(true);
    ex:=false;
    par(7);
    if pc=7 then if ps='MOR' then ex:=true
                 else stop(2,0);
    window(x,y,w,z);
    clrscr;
    y:=z-y;
    findfirst(pstr[6],anyfile,filesp);
    for pn:=1 to filesp.size do begin
      read(infile,ch);
      if ch=#7 then ch:=#32;
      write(ch);
      if ex then if (wherey-1=y) and (wherex=1) then mpage(false);
    end;
    window(1,1,lx,ly);
   end;

  if opt='VIDCOL' then                 { vidcol bw/co/hi/fl }
   begin
    checkp;
    scrns[10]:=savewin(1,1,lx,ly);
    ok:=true;
    detectgraph(j,q);
    ps:=pstr[2];
    if ((ps ='BW') or (ps='CO')) and ((j<6) or (j=7)) then begin
     if lastmode=co80 then textmode(bw80);
     if lastmode=co40 then textmode(bw40);
     ps:='';
    end;
    if ps='BW' then greyscale(true) else
    if ps='CO' then greyscale(false) else
    if ps='HI' then begin
      if (j<3) or (j=7) then begin asm
        mov dx,$3d8
        mov al,$9
        out dx,al
       end; end
      else begin asm
       mov ax,$1003
       mov bl,$0
       int $10
      end; end;
    end else
    if ps='LO' then begin
      if (j<3) or (j=7) then begin asm
        mov dx,$3d8
        mov al,$29
        out dx,al
       end; end
      else begin asm
       mov ax,$1003
       mov bl,$1
       int $10
      end; end;
    end else stop(2,0);
    restwin(0,0,scrns[10],false);
   end;

 if opt='VIDMODE' then                 { vidmode low/norm/med/high }
   begin
    checkp;
    par(2);
    scrns[10]:=savewin(1,1,lx,ly);
    if ps='HIG' then textmode(lo(3)+256) else
    if ps='NOR' then textmode(3) else
    if ps='LOW' then textmode(1) else
    if ps='MED' then
    with reg do
    begin
     ax:=$1202;
     bl:=$30;
     intr($10,reg);
     ax:=$0003;
     intr($10,reg);
     ax:=$1111;
     bl:=$00;
     intr($10,reg);
    end else stop(2,0);
    restwin(0,0,scrns[10],false);
    ok:=true;
    scrnsize;
    cuoff;
    checksnow:=cga;
  end;

 if opt='VIDTYPE' then                      { vidtype }
  begin
   detectgraph(j,q);
   case j of
    -2..0,7: result(1,false);   {mono}
     1..2: result(2,false);     {cga}
     3..5: result(3,false);     {ega}
     6..11: result(4,false);    {vga}
   end;
   ok:=true;
  end;

 if opt='WAIT' then                         { wait (.)dd }
   begin
    ok:=true;
    checkp;
    checkbreak:=true;
    if copy(pstr[2],1,1)='.' then begin
     delete(pstr[2],1,1);
     convert(2,true);
     wait(pn);
    end else begin
     convert(2,true);
     if pn>2147 then stop(6,0);
     wait(pn*1000);
    end;
   end;

 if opt='WILLFIT' then                  { willfit filespec d: }
  begin
   ok:=true;
   if pc<3 then stop(3,0);
   ps:=pstr[3];
   if ps[2]<>':' then stop(2,0);
   ps[1]:=upcase(ps[1]);
   pnn:=diskfree(ord(ps[1])-64);
   reg.dl:=ord(ps[1])-64;
   reg.ah:=$1c;
   msdos(reg);
   x:=integer(reg.al*reg.cx);
   findfirst(pstr[2],anyfile,filesp);
   pn:=filesp.size;
   rn:=pn/x; z2:=pn div x;
   if rn>z2 then pn:=(z2+1)*x
   else pn:=w*x;
   repeat
    findnext(filesp);
    if doserror=0 then begin
     rn:=filesp.size/x; z2:=filesp.size div x;
     if rn>z2 then pn2:=(z2+1)*x
     else pn2:=z2*x;
     pn:=pn+pn2;
    end;
   until doserror<>0;
   if pnn>pn then result(2,true)
   else result(1,true);
  end;

  if opt='WINCOL' then               { wincol xt,yt xb,yb tc bc }
  begin
   ex:=false; sh:=false;
   if pc<5 then stop(3,0);
   xywin(false);
   colour(4);
   if pn=-8 then ex:=true;
   chcol(false);
   colour(5);
   if pn=-8 then sh:=true;
   chcol(true);
   for j:=y to z do for q:=x to w do
                     sc(q,j);
   ok:=true;
  end;

 if opt='WINDISK' then                 { windisk save x,y w,z file (bin) }
  begin                                {         rest file }
    if pc<3 then stop(3,0);
    par(2);
    if ps='SAV' then
    begin
     if pc<5 then stop(3,0);
     pstr[2]:=pstr[3];
     pstr[3]:=pstr[4];
     xywin(false);
     par(6);
     if (pc>5) and (ps<>'BIN') then stop(2,0);
     ps:=pstr[5];
     Assign(infile,ps); Rewrite(infile);
     if ioresult<>0 then stop(4,0);
     if pc=5 then
      write(infile,'== DOS-DO == WinDisk File ',chr(x),chr(y),chr(w),chr(z));
     q:=z-y+1;
     j:=(y-1)*(lo(windmax)+1)*2+(x-1)*2;
     for ii:=1 to q do begin
       for i:=0 to ((w*2-1)-(x*2-2)) do begin
        write(infile,chr(mem[video:j+i]));
        if ioresult<>0 then stop(4,0);
       end;
       inc(j,(lo(windmax)+1)*2);
     end;
     Close(infile);
    end else
    if ps='RES' then
    begin
     ps:=pstr[3];
     Assign(infile,ps); Reset(infile);
     if ioresult<>0 then stop(4,0);
     line:=''; x:=1; y:=1; w:=lx; z:=ly;
     for q:=1 to 26 do begin
      if doserror<>0 then stop(4,0);
      read(infile,ch);
      line:=line+ch;
     end;
     if line<>'== DOS-DO == WinDisk File ' then reset(infile)
     else begin
      read(infile,ch);
      x:=ord(ch);
      read(infile,ch);
      y:=ord(ch);
      read(infile,ch);
      w:=ord(ch);
      read(infile,ch);
      z:=ord(ch);
     end;
     q:=z-y+1;
     j:=(y-1)*(lo(windmax)+1)*2+(x-1)*2;
     for ii:=1 to q do begin
      for i:=0 to ((w*2-1)-(x*2-2)) do begin
       read(infile,ch);
       mem[video:j+i]:=ord(ch);
       if doserror<>0 then goto don;
      end;
      inc(j,(lo(windmax)+1)*2);
     end;
don: Close(infile);
    end else stop(2,0);
    ok:=true;
   end;
 
 if (opt='WINDOW') or (opt='BOX') then  { window tx,ty bx,by tc bc b (expl/ }
  begin                                 {        slid/drop) (shad) }
    if pc<6 then stop(3,0);             { box tx,ty bx,by tc bc b (shad) }
    ok:=true; shape:=0;
    sh:=false; ex:=false;
    xywin(true);
    ps:=pstr[pc];
    if opt='BOX' then begin
      winbox(6,true);
      winbox(7,true);
    end
    else begin
      winbox(6,false);
      winbox(7,false);
      winbox(8,false);
    end;
    colour(4);
    chcol(false);
    colour(5);
    chcol(true);

     if w<=x then w:=w+1;
     if z<=y then z:=y+1;
     if sh and (w>(lx-2)) then w:=lx-2;
     if (z>(ly-1)) and (w=lx-2) and sh then z:=ly-1;
     if ex then explode(x,y,w,z,cofor,cobac,shape)
     else begin
      window(x,y,w,z);
      if opt='WINDOW' then clrscr;
      window(1,1,lx,ly);
      border(x,y,w,z,cofor,cobac,shape);
     end;
     if sh then shad(x,y,w,z);
   end;

 if (opt='WINMEM')  then             { winmem save xx,yy ww,zz scr# }
   begin                             {        rest (xx,yy) scr# (keep) }
    ok:=true;
    par(2);
    if ps='SAV' then begin
     if pc<5 then stop(3,0);
     pstr[2]:=pstr[3];
     pstr[3]:=pstr[4];
     xywin(false);
     convert(5,true);
     if pn>10 then stop(6,0);
     scrns[pn]:=savewin(x,y,w,z);
     if err>0 then stop(9,0);
    end else
    if ps='RES' then begin
     if pc<3 then stop(3,0);
     par(pc);
     if ps='KEE' then begin sh:=false; convert(pc-1,true); end
     else convert(pc,true);
     if pn>10 then stop(6,0);
     j:=pn;
     if pos(',',pstr[3])=0 then x:=0
     else begin
      pstr[2]:=pstr[3];
      xywin(false);
     end;
     restwin(x,y,scrns[j],sh);
    end
    else stop(2,0);
   end;

  if (opt='REM') or (copy(opt,1,1)=':') then ok:=true;
  if not ok then stop(1,0);
end;

procedure from_dec;      { from file fetch & decode ************************}
begin
  opt:=pstr[1];
  if opt<>'FROM' then exit;
    if pc=1 then stop(3,0);
    last:=false; res:=' ';
    fr:=true;
    assign(infile,pstr[2]);
    reset(infile);
    if (ioresult<>0) then stop(4,0);
    endln:=0; loopn:=0;
    while not eof(infile) do begin
     inc(endln);
     new(linebuf[endln]);
     readln(infile,linebuf[endln]^);
     if ioresult<>0 then stop(4,0);
     if endln=850 then stop(5,0);
    end;
    close(infile);
    for linen:=1 to endln do begin
     ok:=false;
     for q:=1 to 20 do pstr[q]:='';
     readit;
     while copy(line,1,1)=' ' do delete(line,1,1);
     q:=1;
     while (q<=length(line)) and (line[q]<>'"') do begin
      line[q]:=upcase(line[q]);
      inc(q);
     end; {uping}
     if (copy(line,1,1)<>':') and (copy(line,1,3)<>'REM') and (line<>'') then
     begin
     pc:=1;
{     if length(line)>99 then stop(5,0);}
     for q:=1 to length(line) do begin
      if (line[q]=' ') and not last then begin
       pc:=pc+1;
       if pc>20 then stop(5,0);
       last:=true;
      end else begin
        pstr[pc]:=pstr[pc]+line[q];
        last:=false;
        end;
     end; {line scan}
     opt:=pstr[1];
     options;
     end; {useful opt}
    end; {line loop}
    stop2(0);
end;

begin                                   { main program flow }
  checkbreak:=false;
  detectgraph(j,q);
  if (j=1) or (j=2) then cga:=true
  else cga:=false;
  checksnow:=cga;
  start;
  from_dec;
  options;
  stop2(0);
end.
