{$I TOOLS.PAS}
var video:longint;
    cutop,cubot,vidpg:integer;

procedure scrn(xx,yy,cha:integer);
begin
  mem[video:((((lo(windmax)+1)*(yy-1))+xx)*2)-2]:=cha;
  mem[video:((((lo(windmax)+1)*(yy-1))+xx)*2)-1]:=textattr;
end;

procedure scr(xx,yy,cha,fore,bac:integer);
begin
  mem[video:((((lo(windmax)+1)*(yy-1))+xx)*2)-1]:=(bac shl 4)+fore;
  mem[video:((((lo(windmax)+1)*(yy-1))+xx)*2)-2]:=cha;
end;

procedure writehorz(cha,times:integer);
begin
 for i:=wherex to (wherex+times-1) do
  scrn(i,wherey,cha);
end;

procedure writevert(cha,times:integer);
var x:integer;
begin
 if wherey+times>ly then times:=ly-wherey+1;
 x:=wherex;
 for i:=wherey to (wherey+times-1) do
  scrn(x,i,cha);
end;

procedure cumod(top,bot:integer);  {top=0, bot=13}
begin
 reg.ah:=$01;
 reg.ch:=top;
 reg.cl:=bot;
 intr($10,reg);
end;

procedure cuget;
begin
  reg.ah:=3;
  reg.bh:=0;
  intr($10,reg);
  cutop:=reg.ch;
  cubot:=reg.cl;
end;

procedure bordercolor(col:integer);
begin
 reg.ah:=$0b;
 reg.bh:=vidpg;
 reg.bl:=col;
 intr($10,reg);
end;

procedure scroll(dir:str130; tx,ty,bx,by,nol,col:integer);
begin
 if dir='UP' then reg.ax:=$0600
 else reg.ax:=$0700;
 reg.ax:=reg.ax + nol;
 reg.bx:=col shl 8;
 reg.cx:=ty shl 8;
 reg.cx:=reg.cx + tx;
 reg.dx:=by shl 8;
 reg.dx:=reg.dx + bx;
 intr($10,reg);
end;

procedure greyscale(onoff:boolean);
begin
 if onoff then ii:=$1200
 else ii:=$1201;
asm
 mov ax,ii
 mov bl,$33
 int $10
 mov ah,$0f
 int $10
 mov ah,00
 int $10
end; end;

procedure getchar(xx,yy:integer; var chaa,fore,bac:integer);
begin
 reg.ax:=$0300; {store loc}
 reg.bx:=vidpg;
 intr($10,reg);
 q:=reg.dx;
 reg.ax:=$0200; {goto new loc}
 reg.bx:=vidpg;
 reg.dx:=(yy shl 8)+ xx;
 intr($10,reg);
 reg.ax:=$0800; {get char at loc}
 reg.bx:=vidpg;
 intr($10,reg);
 chaa:=lo(reg.ax);
 bac:=(hi(reg.ax) shr 4);
 fore:=(hi(reg.ax) shl 12);
 fore:=fore shr 12;
 reg.ax:=$0200; {go to old loc}
 reg.bx:=vidpg;
 reg.dx:=q;
 intr($10,reg);
end;

procedure videoini;
begin
 video:=$b800;
 if lastmode=mono then video:=$b000;
 reg.ah:=$0f;
 intr($10,reg);
 vidpg:=reg.bh;
end;

function savewin(tx,ty,bx,by:byte):pointer;
var winarr:array[0..5] of byte;
    winptr,wptr:pointer;
    nlines,nchars:integer;
    scrofs:longint;
begin
 err:=0;
 nlines:=by-ty+1;
 nchars:=(bx-tx+1)*2;
 ii:=nlines*nchars+sizeof(winarr);
 getmem(winptr,ii);
 if winptr=nil then begin err:=1; exit; end;
 wptr:=winptr;
 scrofs:=(ty-1)*(lo(windmax)+1)*2+(tx-1)*2;
 winarr[0]:=tx;
 winarr[1]:=ty;
 winarr[2]:=bx;
 winarr[3]:=by;
 winarr[4]:=wherex;
 winarr[5]:=wherey;
 move(winarr,winptr^,sizeof(winarr));
 winptr:=pointer(longint(winptr)+sizeof(winarr));
 for ii:=1 to nlines do begin
  move(mem[video:scrofs],winptr^,nchars);
  winptr:=pointer(longint(winptr)+nchars);
  inc(scrofs,(lo(windmax)+1)*2);
 end;
 savewin:=wptr;
end;

procedure restwin(xx,yy:integer; var winptr:pointer; loseit:boolean);
var winarr:array[0..5] of byte;
    wptr:pointer;
    nlines,nchars,c,l:integer;
    scrofs:longint;
    cux,cuy:integer;
begin
 if winptr=nil then exit;
 wptr:=winptr;
 move(winptr^,winarr,sizeof(winarr));
 nlines:=winarr[3]-winarr[1]+1;
 nchars:=(winarr[2]-winarr[0]+1);
 l:=nlines; c:=nchars;
 if xx=0 then begin xx:=winarr[0]; yy:=winarr[1]; end;
 if (yy+nlines-1)>ly then l:=ly-yy+1;
 if (xx+nchars-1)>lx then c:=lx-xx+1;
 nchars:=nchars*2; c:=c*2;
 scrofs:=(yy-1)*(lo(windmax)+1)*2+(xx-1)*2;
 cux:=winarr[4]; cuy:=winarr[5];
 gotoxy(cux,cuy);
 winptr:=pointer(longint(winptr)+sizeof(winarr));
 for ii:=1 to l do begin
  move(winptr^,mem[video:scrofs],c);
  winptr:=pointer(longint(winptr)+nchars);
  inc(scrofs,(lo(windmax)+1)*2);
 end;
 if loseit then begin
  ii:=nlines*nchars+sizeof(winarr);
  freemem(wptr,ii);
  winptr:=nil;
 end else winptr:=wptr;
end;

procedure border(tx,ty,tw,tz,fore,bac,bord:integer);
const a:array[0..11] of integer=(217,218,191,192,196,179,188,201,187,200,205,186);
begin
 if bord=0 then exit;
 if bord=2 then ii:=6 else ii:=0;
 scr(tw,tz,a[ii],fore,bac);
 scr(tx,ty,a[ii+1],fore,bac);
 scr(tw,ty,a[ii+2],fore,bac);
 scr(tx,tz,a[ii+3],fore,bac);
 for q:=(tx+1) to (tw-1) do
  scr(q,ty,a[ii+4],fore,bac);
 for q:=(ty+1) to (tz-1) do
 begin
  scr(tx,q,a[ii+5],fore,bac);
  scr(tw,q,a[ii+5],fore,bac);
 end;
 for q:=(tx+1) to (tw-1) do
  scr(q,tz,a[ii+4],fore,bac);
end;

procedure explode(x,y,w,z,fore,bac,bord:integer);
var tx,ty,tw,tz,c,q,j,cx,cy:integer;
begin
 cx:=((x+w) div 2);
 cy:=((y+z) div 2);
 c:=w-cx;
 if (z-cy) > c then c:=z-cy;
 c:=(c div 4)+1;
 j:=0;
 for q:=1 to c do
 begin
  wait(10);
  j:=j+4;
  tx:=cx-j;
  ty:=cy-(j div 2);
  tw:=cx+j;
  tz:=cy+(j div 2);
  if tx<x then tx:=x;
  if ty<y then ty:=y;
  if tw>w then tw:=w;
  if tz>z then tz:=z;
  window(tx,ty,tw,tz);
  clrscr;
  window(1,1,lx,ly);
  border(tx,ty,tw,tz,fore,bac,bord);
 end;
end;

procedure implode(xx,yy,ww,zz:integer);
var flag:boolean;
begin
 flag:=false;
 repeat
  wait(10);
  for q:=xx to ww do
   scr(q,yy,32,0,0);
  for q:=yy to zz do
   scr(xx,q,32,0,0);
  for q:=ww downto xx do
   scr (q,zz,32,0,0);
  for q:=zz downto yy do
   scr(ww,q,32,0,0);
  if zz=yy then flag:=true;
  dec(ww); dec(zz);
  inc(xx); inc(yy);
 until flag;
 for q:=xx to zz do
  scr(q,yy,32,0,0);
end;

procedure wallpaper(fore,bac:integer);
var q:integer;
begin
  textcolor(fore);
  textbackground(bac);
  clrscr;
  for q:=1 to (lo(windmax)+1) do
  begin
   for ii:=2 to hi(windmax) do
    scr(q,ii,176,9,7);
  end;
end;

procedure shad(x,y,w,z:integer);
var cc,fore,bac:integer;
begin
  for ii:=1 to (z-y) do
  begin
   getchar((w),(y+ii-1),cc,fore,bac);
   if fore>127 then
    fore:=135
   else fore:=7;
   scr(w+1,y+ii,cc,fore,0);
   getchar((w+1),(y+ii-1),cc,fore,bac);
   if fore>127 then
    fore:=135
   else fore:=7;
   scr(w+2,y+ii,cc,fore,0);
  end;
  for ii:=0 to (w-x) do
  begin
   getchar(x+1+ii,Z,cc,fore,bac);
   if fore>127 then
    fore:=135
   else fore:=7;
   scr(x+2+ii,z+1,cc,fore,0);
  end;
end;

procedure win(x,y,w,z,fore,bac,bord:integer; explw,shadw:boolean);
begin
 textcolor(fore);
 textbackground(bac);
 if explw then explode(x,y,w,z,fore,bac,bord) else
 begin
  window(x,y,w,z);
  clrscr;
  if bord>0 then border(x,y,w,z,fore,bac,bord);
 end;
 if shadw then shad(x,y,w,z);
 window(x,y,w,z);
end;